// BonDebug.cpp: fobO⏕Cu
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include <TChar.h>
#include <StdLib.h>


/////////////////////////////////////////////////////////////////////////////
// ėpONX
/////////////////////////////////////////////////////////////////////////////

CBonException::CBonException(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId)
	: m_ClassId(ClassId)
	, m_lpszSourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
{
	// 
	::_tcscpy(m_szDescription, TEXT("OɊւ͂܂"));
}

CBonException::~CBonException(void)
{
	// Ȃ
}

CBonException & CBonException::operator( )(LPCTSTR lpszFormat, ...)
{
	// 
	va_list Args;
	va_start(Args ,lpszFormat);
	::_vstprintf(m_szDescription, lpszFormat, Args);
	va_end(Args);
	
	return *this;
}

void CBonException::Notify(const bool bEnable)
{
	// Oʒm
	TCHAR szOutput[1024] = TEXT("");
	TCHAR szSource[1024] = TEXT("sȃ\[Xt@C");
	
	// \[Xt@C擾
	GetSourceFile(szSource);
	
	if(m_ClassId != ::GetGuid()){
		TCHAR szModuleName[BON_MAX_MODULE_NAME] = TEXT("s");
		TCHAR szClassName[BON_MAX_CLASS_NAME]	= TEXT("s");
		
		// NX擾
		::GET_BON_CLASS_NAME(m_ClassId, szClassName);
		
		// W[擾
		::GET_BON_MODULE_NAME(::GET_BON_CLASS_MODULE(m_ClassId), szModuleName);
		
		// fobOo͕񐶐
		::_stprintf(szOutput, TEXT("[OCxg]\r\n@Eꏊ\tF %sW[@%sNX\r\n@E\[X\tF %s@%lu s\r\n@E\tF %s\r\n"), szModuleName, szClassName, szSource, m_dwSourceLine, m_szDescription);
		}
	else{
		// fobOo͕񐶐
		::_stprintf(szOutput, TEXT("[OCxg]\r\n@Eꏊ\tF O[o͔BonNX\r\n@E\[X\tF %s@%lu s\r\n@E\tF %s\r\n"), szSource, m_dwSourceLine, m_szDescription);
		}

	// fobOo
	::OutputDebugString(szOutput);

	// CxgOɏo
		// ܂

	// [Uɒʒm
	if(bEnable){
		::_tcscat(szOutput, TEXT("\r\n\r\nO𖳎ăvO̎sp܂H"));

		if(::MessageBox(NULL, szOutput, TEXT("BonSDK Oʒm"), MB_YESNO | MB_ICONERROR | MB_TASKMODAL) == IDYES){
			// sp
			return;
			}

		// fobOu[N
		::DebugBreak();
		}
}

const BONGUID CBonException::GetGuid(void)
{
	// OBONGUIDԂ
	return m_ClassId;
}

const DWORD CBonException::GetDescription(LPTSTR lpszDescription)
{
	// O̐Ԃ
	if(lpszDescription)::_tcscpy(lpszDescription, m_szDescription);

	// Ԃ
	return ::_tcslen(m_szDescription);
}

const DWORD CBonException::GetSourceFile(LPTSTR lpszSourceFile)
{
	// Õ\[Xt@CԂ
	TCHAR szPathName[_MAX_PATH] = TEXT("");
	TCHAR szFileName[_MAX_FNAME] = TEXT("");
	TCHAR szExtName[_MAX_EXT] = TEXT("");

#ifdef _UNICODE
	// UNICODEɕϊ
	::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, m_lpszSourceFile, -1, szPathName, sizeof(szPathName));
#else
	// ̂܂܃Rs[
	::_tcscpy(szPathName, m_lpszSourceFile);
#endif

	// t@C𒊏o
	::_tsplitpath(szPathName, NULL, NULL, szFileName, szExtName);
	::_tmakepath(szPathName, NULL, NULL, szFileName, szExtName);	

	if(lpszSourceFile)::_tcscpy(lpszSourceFile, szPathName);

	// Ԃ
	return ::_tcslen(szPathName);
}

const DWORD CBonException::GetSourceLine(void)
{
	// Õ\[XR[hsԂ
	return m_dwSourceLine;
}


/////////////////////////////////////////////////////////////////////////////
// ėpƍNX
/////////////////////////////////////////////////////////////////////////////

CBonAssert::CBonAssert(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId)
	: m_lpszSourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_ClassId(ClassId)
{
	// Ȃ
}

void CBonAssert::operator( )(const bool bSuccess, LPCTSTR lpszFormat, ...)
{
	// 
	if(!bSuccess){
		// OIuWFNg
		CBonException Exception(m_lpszSourceFile, m_dwSourceLine, m_ClassId);
		
		if(lpszFormat){
			TCHAR szDescription[1024] = TEXT("");

			// tH[}bg
			va_list Args;
			va_start(Args , lpszFormat);
			::_vstprintf(szDescription, lpszFormat, Args);
			va_end(Args);
			Exception(szDescription);
			}

		// O𔭐
		Exception.Notify();
		}
}

void CBonAssert::operator( )(const void *pPointer, LPCTSTR lpszFormat, ...)
{
	// |C^
	if(!pPointer){
		// OIuWFNg
		CBonException Exception(m_lpszSourceFile, m_dwSourceLine, m_ClassId);
		
		if(lpszFormat){
			TCHAR szDescription[1024] = TEXT("");

			// tH[}bg
			va_list Args;
			va_start(Args , lpszFormat);
			::_vstprintf(szDescription, lpszFormat, Args);
			va_end(Args);
			Exception(szDescription);
			}

		// O𔭐
		Exception.Notify();
		}
}


/////////////////////////////////////////////////////////////////////////////
// fobO⏕֐
/////////////////////////////////////////////////////////////////////////////

const BONGUID GetGuid(void)
{
	// O[oXR[v̏ꍇBCID_NULLԂ
	return BCID_NULL;
}

void BON_TRACE(LPCTSTR lpszFormat, ...)
{
	TCHAR szOutput[1024] = TEXT("");

	// bZ[W
	va_list Args;
	va_start(Args , lpszFormat);
	::_vstprintf(szOutput, lpszFormat, Args);
	va_end(Args);

	// fobOo͂ɏ
	::OutputDebugString(szOutput);
}
