// Multi2DecDos.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Multi2DecDosApp.h"




// t@C[J֐vg^Cv
static void PrintUsage(void);
static const bool ParseParam(CMulti2DecDosApp::CONFIGSET * const pConfigSet, const int iParamNum, LPTSTR aszParam[]);
static LPCTSTR FindParam(const int iParamNum, LPTSTR aszParam[], LPCTSTR lpszFind);
static const bool ParsePath(CMulti2DecDosApp::CONFIGSET * const pConfigSet);




// Gg[|Cg
int _tmain(int argc, _TCHAR* argv[])
{
	CMulti2DecDosApp::CONFIGSET ConfigSet;
	CMulti2DecDosApp App(NULL);

	// o[V
	::printf("\n- Multi2DecDos Ver.2.10 - http://2sen.dip.jp/dtv/\n\n");

	// p[^
	if(!ParseParam(&ConfigSet, argc, argv)){
		// p[^s
		PrintUsage();
		return -1;	
		}

	// t@C𐶐
	if(!ParsePath(&ConfigSet)){
		// t@Cs
		return -1;
		}

	// Ro[gs
	if(!App.Run(&ConfigSet)){
		return -1;
		}

	return 0;
}

static void PrintUsage(void)
{
	// wv\
	::printf("\nMulti2DecDos [[/D | /C | /U] | [/OUT] [/B25] [/EMM] [/PURE] [/NULL]] [/N]\n");
	::printf("             ̓t@C [o̓t@C]\n\n");
	::printf("  /D            XNus܂B(ftHg)\n");
	::printf("  /C            TSt@C̃G[`FbNs܂B\n");
	::printf("  /U            B-CASJ[ȟ_̍XVs܂B(EMM)\n");
	::printf("  /OUT          t@Co͂܂B\n");
	::printf("  /B25          Multi2s܂B\n");
	::printf("  /EMM          EMMs܂B\n");
	::printf("  /PURE         RpPbgo͂܂B\n");
	::printf("  /NULL         NULLpPbgo͂܂B\n");
	::printf("  /N            Ot@Co͂܂B\n");
	::printf("  ̓t@C  TSt@C̃pX\n");
	::printf("  o̓t@C  TSt@C̃pX\n\n");
}

static const bool ParseParam(CMulti2DecDosApp::CONFIGSET * const pConfigSet, const int iParamNum, LPTSTR aszParam[])
{
	// ftHgp[^(/D )
	pConfigSet->bOutput = true;
	pConfigSet->bB25	= true;
	pConfigSet->bEMM	= false;
	pConfigSet->bPURE	= false;
	pConfigSet->bNULL	= true;
	pConfigSet->bNoLog	= false;
	pConfigSet->szInputPath[0] = TEXT('\0');
	pConfigSet->szOutputPath[0] = TEXT('\0');

	// t@C
	if(iParamNum >= 3){
		if((aszParam[iParamNum - 2][0] != TEXT('/')) && (aszParam[iParamNum - 1][0] != TEXT('/'))){
			// /o̓t@Cۑ
			::lstrcpy(pConfigSet->szInputPath,  aszParam[iParamNum - 2]);
			::lstrcpy(pConfigSet->szOutputPath, aszParam[iParamNum - 1]);
			}
		else if(aszParam[iParamNum - 1][0] != TEXT('/')){
			// ̓t@Cۑ
			::lstrcpy(pConfigSet->szInputPath, aszParam[iParamNum - 1]);
			}
		else{
			// t@CȂ
			::printf("G[: ̓t@Cw肳Ă܂B\n");
			return false;
			}		
		}
	else if(iParamNum >= 2){
		if(aszParam[1][0] != TEXT('/')){
			// ̓t@Cۑ
			::lstrcpy(pConfigSet->szInputPath, aszParam[1]);
			return true;
			}
		else{
			// t@CȂ
			::printf("G[: ̓t@Cw肳Ă܂B\n");
			return false;
			}		
		}
	else{
		// p[^1Ȃ
		::printf("G[: p[^w肳Ă܂B\n");
		return false;
		}

	// Oo͐p[^
	pConfigSet->bNoLog = (FindParam(iParamNum, aszParam, TEXT("/N")))? true : false;

	// vZbgp[^
	int iPresetNum = 0;
		
	if(FindParam(iParamNum, aszParam, TEXT("/D"))){
		// /D
		iPresetNum++;
		pConfigSet->bOutput = true;
		pConfigSet->bB25	= true;
		pConfigSet->bEMM	= false;
		pConfigSet->bPURE	= false;
		pConfigSet->bNULL	= true;
		}

	if(FindParam(iParamNum, aszParam, TEXT("/C"))){
		// /C
		iPresetNum++;
		pConfigSet->bOutput = false;
		pConfigSet->bB25	= false;
		pConfigSet->bEMM	= false;
		pConfigSet->bPURE	= false;
		pConfigSet->bNULL	= true;
		}

	if(FindParam(iParamNum, aszParam, TEXT("/U"))){
		// /U
		iPresetNum++;
		pConfigSet->bOutput = false;
		pConfigSet->bB25	= true;
		pConfigSet->bEMM	= true;
		pConfigSet->bPURE	= false;
		pConfigSet->bNULL	= true;
		}

	if(iPresetNum == 1){
		// vZbg[h
		return true;
		}
	else if(iPresetNum > 1){
		::printf("G[: /D /C /U p[^͓1wł܂B\n");
		return false;
		}

	// JX^p[^
	pConfigSet->bOutput = (FindParam(iParamNum, aszParam, TEXT("/OUT")))?  true : false;
	pConfigSet->bB25	= (FindParam(iParamNum, aszParam, TEXT("/B25")))?  true : false;
	pConfigSet->bEMM	= (FindParam(iParamNum, aszParam, TEXT("/EMM")))?  true : false;
	pConfigSet->bPURE	= (FindParam(iParamNum, aszParam, TEXT("/PURE")))? true : false;
	pConfigSet->bNULL	= (FindParam(iParamNum, aszParam, TEXT("/NULL")))? true : false;

	return true;
}

static LPCTSTR FindParam(const int iParamNum, LPTSTR aszParam[], LPCTSTR lpszFind)
{
	// p[^Xgw肵
	for(int i = 1 ; i < iParamNum ; i++){
		if(!::lstrcmpi(aszParam[i], lpszFind)){
			return aszParam[i];
			}		
		}

	return NULL;
}

static const bool ParsePath(CMulti2DecDosApp::CONFIGSET * const pConfigSet)
{
	const int iInputLen = ::lstrlen(pConfigSet->szInputPath);

	// t@C`FbN
	if(iInputLen < 4){
		::printf("G[: ̓t@CZ܂B\n");
		return false;
		}
		
	// t@CpX`FbN
	if(::lstrcmpi(&pConfigSet->szInputPath[iInputLen - 3], TEXT(".ts"))){
		::printf("G[: ̓t@C̊gqTSt@Cł͂܂B\n");
		return false;
		}

	// o̓t@CpX𐶐
	if(pConfigSet->szOutputPath[0] == TEXT('\0')){
		::lstrcpy(pConfigSet->szOutputPath, pConfigSet->szInputPath);
		pConfigSet->szOutputPath[iInputLen - 3] = TEXT('\0');
		::lstrcat(pConfigSet->szOutputPath, TEXT("_dec.ts"));
		}

	return true;
}
