// TsConverterIf.h: TSRo[^C^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// Multi2Ro[^C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IMulti2Converter :		public IBonObject
{
public:
	// Multi2Ro[^nhC^tF[X
	class IHandler :	public IBonObject
	{
	public:
		virtual void OnMulti2ConverterEvent(IMulti2Converter *pMulti2Converter, const DWORD dwEventID, PVOID pParam) = 0;
	};

	enum	// Ro[^CxgID				// [Cxge]				[pParam]
	{
		EID_CONV_START		= 0x00000000UL,		// Ro[gJn				N/A
		EID_CONV_END		= 0x00000001UL,		// Ro[gI				N/A
		EID_CONV_PROGRESS	= 0x00000002UL,		// Ro[gi				100%/1000
		EID_CONV_ERROR		= 0x00000003UL		// G[					N/A
	};

	enum	// StartConvert() G[R[h
	{
		EC_NO_ERROR			= 0x00000000UL,		// G[Ȃ
		EC_FILE_ERROR		= 0x00000001UL,		// t@CJȂ
		EC_BCAS_ERROR		= 0x00000002UL,		// B-CASJ[hJȂ
		EC_CLASS_ERROR		= 0x00000003UL,		// KvȃNXȂ
		EC_INTERNAL_ERROR	= 0x00000004UL		// ̑G[
	};

	virtual const DWORD StartConvert(LPCTSTR lpszSrcFile, LPCTSTR lpszDstFile, const bool bB25 = true, const bool bEMM = false, const bool bNULL = false, const bool bDiscard = false) = 0;
	virtual void EndConvert(void) = 0;
	
	virtual const DWORD GetPacketStride(void) const = 0;
	virtual const DWORD GetInputPacketNum(const WORD wPID = TS_INVALID_PID) const = 0;
	virtual const DWORD GetOutputPacketNum(const WORD wPID = TS_INVALID_PID) const = 0;
	virtual const DWORD GetSyncErrNum(void) const = 0;
	virtual const DWORD GetFormatErrNum(void) const = 0;
	virtual const DWORD GetTransportErrNum(void) const = 0;
	virtual const DWORD GetContinuityErrNum(const WORD wPID = TS_INVALID_PID) const = 0;
	virtual const DWORD GetScramblePacketNum(const WORD wPID = TS_INVALID_PID) const = 0;
	virtual const DWORD GetEcmProcessNum(void) const = 0;
	virtual const DWORD GetEmmProcessNum(void) const = 0;
	
	virtual const ULONGLONG GetSrcFileLength(void) const = 0;
	virtual const ULONGLONG GetDstFileLength(void) const = 0;
};
